# -*- coding: utf-8 -*-
# Generated by Django 1.11.27 on 2021-06-02 22:34
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import ishtar_common.models_common
import re


class Migration(migrations.Migration):

    dependencies = [
        ('archaeological_finds', '0107_auto_20201203_1453'),
    ]

    operations = [
        migrations.CreateModel(
            name='FunctionalArea',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', models.TextField(verbose_name='Label')),
                ('txt_idx', models.TextField(help_text='The slug is the standardized version of the name. It contains only lowercase letters, numbers and hyphens. Each slug must be unique.', unique=True, validators=[django.core.validators.RegexValidator(re.compile('^[-a-zA-Z0-9_]+\\Z', 32), "Enter a valid 'slug' consisting of letters, numbers, underscores or hyphens.", 'invalid')], verbose_name='Textual ID')),
                ('comment', models.TextField(blank=True, default='', verbose_name='Comment')),
                ('available', models.BooleanField(default=True, verbose_name='Available')),
                ('parent', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='archaeological_finds.FunctionalArea', verbose_name='Parent')),
            ],
            options={
                'verbose_name': 'Functional area',
                'verbose_name_plural': 'Functional areas',
                'ordering': ('parent__label', 'label'),
            },
            bases=(ishtar_common.models_common.Cached, models.Model),
        ),
        migrations.AlterField(
            model_name='find',
            name='collection',
            field=models.ForeignKey(blank=True, help_text='Do not use - need evolutions', null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='finds', to='archaeological_warehouse.Warehouse', verbose_name='Collection'),
        ),
        migrations.AlterField(
            model_name='historicalfind',
            name='collection',
            field=models.ForeignKey(blank=True, db_constraint=False, help_text='Do not use - need evolutions', null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='archaeological_warehouse.Warehouse', verbose_name='Collection'),
        ),
        migrations.AddField(
            model_name='find',
            name='functional_areas',
            field=models.ManyToManyField(blank=True, related_name='find', to='archaeological_finds.FunctionalArea', verbose_name='Functional area'),
        ),
    ]
